using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using MagSiteLib;

namespace MagSite
{
	public class SiteMap : System.Web.UI.Page
	{
		private const string sitemapNS = "http://www.sitemaps.org/schemas/sitemap/0.9";

		public static DateTime GetItemLastUpdatedDateTime( ItemID itemID )
		{
			
			return DateTime.MinValue;
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			Response.ContentType = "application/xml";
			Response.ContentEncoding = System.Text.Encoding.UTF8;

			XmlTextWriter writer = new XmlTextWriter(Response.OutputStream,System.Text.Encoding.UTF8);
			try
			{
				writer.WriteStartDocument();
				writer.Formatting = Formatting.Indented;

				writer.WriteStartElement("urlset",sitemapNS);

				ItemID [] items = ItemListManager.ContentList.GetItemIDsIncludingSubKeywords(FullKeyword.RootKeyword);
				foreach( ItemID itemID in items )
				{
					if( !itemID.IsNormalItemID() ) continue;
					writer.WriteStartElement("url",sitemapNS);
					writer.WriteElementString("loc",sitemapNS,WriteLib.BuildContentAbsoluteUrl(Request.Url,itemID));

					string filename = FileLayout.GetContentFileName(itemID,ItemListManager.ContentList.GetFullKeyword(itemID));
					DateTime lastUpdated = File.GetLastWriteTimeUtc(filename);
					writer.WriteElementString("lastmod",sitemapNS,RssUtility.FormatRssDate(lastUpdated));

					// Ƃ肠monthlyɂĂA̓AoEgȉ̎w
					writer.WriteElementString("changefreq","monthly");

					writer.WriteEndElement();
				}

				writer.WriteEndElement();
				writer.WriteEndDocument();
			}
			finally
			{
				writer.Flush();
			}
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
